type token =
  | SEMI
  | LPAREN
  | RPAREN
  | LBRACE
  | RBRACE
  | COMMA
  | LBRACKET
  | RBRACKET
  | PLUS
  | MINUS
  | TIMES
  | DIVIDE
  | ASSIGN
  | NOT
  | MPLUS
  | MMINUS
  | MTIMES
  | CONV
  | DOT
  | EQ
  | NEQ
  | LT
  | LEQ
  | GT
  | GEQ
  | TRUE
  | FALSE
  | AND
  | OR
  | RETURN
  | IF
  | ELSE
  | FOR
  | WHILE
  | INT
  | BOOL
  | VOID
  | IMAGE
  | STRING
  | MATRIX
  | FLOAT
  | WIDTH
  | HEIGHT
  | PIXEL
  | LITERAL of (int)
  | FLOAT_LITERAL of (float)
  | ID of (string)
  | STRING_LIT of (string)
  | EOF

val program :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Ast.program
